#BrlTex
#Copyright (c) Michael Whapples 2007
#Original author: Michael Whapples, mwhapples@users.sourceforge.net
#Released under the RPL, see license for details
def linewrap(intext, linelen, linewrap, pagelen, numstyle):
	pages = intext.split('\f')
	pagenum = 1
	outlist = []
	for page in pages:
		lines = page.split('\n')
		linenum = 1
		for line in lines:
			if linenum == 1:
				curlen = linelen - len(numstyle(str(pagenum))) - 2
			else:
				curlen = linelen
			if len(line) <= curlen:
				outlist.append(line)
				if linenum == 1:
					while len(outlist[-1]) < curlen:
						outlist[-1] += ' '
					outlist.append('  ')
					outlist.append(numstyle(str(pagenum)))
					linenum += 1 
				elif linenum == pagelen:
					linenum = 1
					#outlist.append('\f')
					pagenum += 1
				else:
					linenum += 1
				outlist.append('\n')
				if linenum == 1:
					outlist.append('\f')
				continue
			while len(line)> 0:
				if linenum == 1:
					curlen = linelen - len(numstyle(str(pagenum))) - 2
				else:
					curlen = linelen
				splitpos = 0
				splitval = ''
				splitkey = ''
				for key, val in linewrap.items():
					checkpos = line[:curlen -len(val.split('\n')[0])].rfind(key)
					if checkpos > splitpos:
						splitpos = checkpos
						splitval = val
						splitkey = key
				line = line[:splitpos] + line[splitpos:].replace(splitkey, splitval, 1)
				outlist.append(line.split('\n')[0])
				line = ''.join(line.split('\n')[1:])
				if linenum == 1:
					while len(outlist[-1]) < curlen:
						outlist[-1] += ' '
					outlist.append('  ')
					outlist.append(numstyle(str(pagenum)))
					linenum += 1
				elif linenum == pagelen:
					linenum = 1
					#outlist.append('\f')
					pagenum += 1
				else:
					linenum += 1
				outlist.append('\n')
				if linenum == 1:
					outlist.append('\f')
		linenum = 1
		pagenum += 1
		outlist.append('\f')
	if outlist[-1] == '\f':
		munch = outlist.pop(-1)
	return ''.join(outlist)

