import os, globalvars, platform, shutil
def compile():
	curdir = os.getcwd()
	os.chdir(os.path.join(globalvars.brltex_dir, 'liblouis-src'))
	if platform.system() == 'Linux':
		shutil.copyfile('linux-Makefile', 'Makefile')
	elif platform.system() == 'Windows':
		shutil.copyfile('windows-Makefile', 'Makefile')
	elif platform.system() == 'Darwin':
		shutil.copyfile('macosx-Makefile', 'Makefile')
	if platform.system() == 'Windows':
		makecommand = 'vcvars32.bat && nmake liblouis-112.dll'
	else:
		makecommand = 'make'
	if os.system(makecommand):
		return False
	os.chdir(curdir)
	if platform.system() == 'Linux':
		shutil.copy(os.path.join('liblouis-src', 'liblouis.so.1'), os.path.join(globalvars.brltex_dir, 'liblouis', 'liblouis.so'))
	elif platform.system() == 'Windows':
		shutil.copy(os.path.join('liblouis-src', 'liblouis-112.dll'), os.path.join(globalvars.brltex_dir, 'liblouis', 'liblouis.dll'))
	elif platform.system() == 'Darwin':
		shutil.compy(os.path.join('liblouis-src', 'liblouis.dylib'), os.path.join(globalvars.brltex_dir, 'liblouis', 'liblouis.dylib'))
	return True

