#BrlTex
#Copyright (C) 2006-2007 Michael Whapples, All Rights Reserved.
#Original Author: Michael Whapples, mwhapples@users.sourceforge.net
#Unless linsor has explicitly granted you any other licensing terms, the contents of this file is subject to the RPL 
1.1, 
#available at the BrlTex website (http://brltex.sourceforge.net).
#All software distributed under the Licenses is provided strictly on an "AS IS" basis,
#WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, AND the licensor
#HEREBY DISCLAIMS ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES
#OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT, OR NON-INFRINGEMENT.
#Licensor reserves the right to change the Venue stated in the license to the UK.

from plasTeX import Command, Environment

#Add any custom macros here
#For the macro to be used by BrlTex, you must add it to macroDict

class sqrt(Command):
	'''Sees to the \sqrt command'''
	args = ' [ self ] text '

class enuminame(Environment):
	'''This sees to the enumerate environment, it works fine, but we just want to suppress the warnings.'''
	pass

macroDict = {'sqrt': sqrt, 'enuminame': enuminame}
